#include <stdio.h>
#include <math.h>
int p, k, pe;

int deriv (int p) {
    int d = 0, j = 0, f = 0;
    if (p == 1) return 0;
    j = (int) sqrt(p);
    for (d = 2; d <= j; d ++) {
        if (!(p % d)) {
           f = 1;
           break;
        }
    }
    if (f) {
       return (deriv(d) * (p / d) + d * deriv(p / d));
    } else {
       return 1;
    }
}

int main () {
    int i = 0;
    scanf ("%d%d", &p, &k);
    pe = p;
    for (i = 0; i < k; i ++) {
        pe = deriv(pe);
    }
    printf ("%d\n", pe);
    return 0;
}

